# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

class WfmBuScheduleRunTopicBuScheduleRun(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        WfmBuScheduleRunTopicBuScheduleRun - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'id': 'str',
            'week_count': 'int',
            'schedule': 'WfmBuScheduleRunTopicBuScheduleReference',
            'scheduling_canceled_by_user': 'WfmBuScheduleRunTopicUserReference',
            'scheduling_completed_time': 'str',
            'message_count': 'int'
        }

        self.attribute_map = {
            'id': 'id',
            'week_count': 'weekCount',
            'schedule': 'schedule',
            'scheduling_canceled_by_user': 'schedulingCanceledByUser',
            'scheduling_completed_time': 'schedulingCompletedTime',
            'message_count': 'messageCount'
        }

        self._id = None
        self._week_count = None
        self._schedule = None
        self._scheduling_canceled_by_user = None
        self._scheduling_completed_time = None
        self._message_count = None

    @property
    def id(self):
        """
        Gets the id of this WfmBuScheduleRunTopicBuScheduleRun.


        :return: The id of this WfmBuScheduleRunTopicBuScheduleRun.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this WfmBuScheduleRunTopicBuScheduleRun.


        :param id: The id of this WfmBuScheduleRunTopicBuScheduleRun.
        :type: str
        """
        
        self._id = id

    @property
    def week_count(self):
        """
        Gets the week_count of this WfmBuScheduleRunTopicBuScheduleRun.


        :return: The week_count of this WfmBuScheduleRunTopicBuScheduleRun.
        :rtype: int
        """
        return self._week_count

    @week_count.setter
    def week_count(self, week_count):
        """
        Sets the week_count of this WfmBuScheduleRunTopicBuScheduleRun.


        :param week_count: The week_count of this WfmBuScheduleRunTopicBuScheduleRun.
        :type: int
        """
        
        self._week_count = week_count

    @property
    def schedule(self):
        """
        Gets the schedule of this WfmBuScheduleRunTopicBuScheduleRun.


        :return: The schedule of this WfmBuScheduleRunTopicBuScheduleRun.
        :rtype: WfmBuScheduleRunTopicBuScheduleReference
        """
        return self._schedule

    @schedule.setter
    def schedule(self, schedule):
        """
        Sets the schedule of this WfmBuScheduleRunTopicBuScheduleRun.


        :param schedule: The schedule of this WfmBuScheduleRunTopicBuScheduleRun.
        :type: WfmBuScheduleRunTopicBuScheduleReference
        """
        
        self._schedule = schedule

    @property
    def scheduling_canceled_by_user(self):
        """
        Gets the scheduling_canceled_by_user of this WfmBuScheduleRunTopicBuScheduleRun.


        :return: The scheduling_canceled_by_user of this WfmBuScheduleRunTopicBuScheduleRun.
        :rtype: WfmBuScheduleRunTopicUserReference
        """
        return self._scheduling_canceled_by_user

    @scheduling_canceled_by_user.setter
    def scheduling_canceled_by_user(self, scheduling_canceled_by_user):
        """
        Sets the scheduling_canceled_by_user of this WfmBuScheduleRunTopicBuScheduleRun.


        :param scheduling_canceled_by_user: The scheduling_canceled_by_user of this WfmBuScheduleRunTopicBuScheduleRun.
        :type: WfmBuScheduleRunTopicUserReference
        """
        
        self._scheduling_canceled_by_user = scheduling_canceled_by_user

    @property
    def scheduling_completed_time(self):
        """
        Gets the scheduling_completed_time of this WfmBuScheduleRunTopicBuScheduleRun.


        :return: The scheduling_completed_time of this WfmBuScheduleRunTopicBuScheduleRun.
        :rtype: str
        """
        return self._scheduling_completed_time

    @scheduling_completed_time.setter
    def scheduling_completed_time(self, scheduling_completed_time):
        """
        Sets the scheduling_completed_time of this WfmBuScheduleRunTopicBuScheduleRun.


        :param scheduling_completed_time: The scheduling_completed_time of this WfmBuScheduleRunTopicBuScheduleRun.
        :type: str
        """
        
        self._scheduling_completed_time = scheduling_completed_time

    @property
    def message_count(self):
        """
        Gets the message_count of this WfmBuScheduleRunTopicBuScheduleRun.


        :return: The message_count of this WfmBuScheduleRunTopicBuScheduleRun.
        :rtype: int
        """
        return self._message_count

    @message_count.setter
    def message_count(self, message_count):
        """
        Sets the message_count of this WfmBuScheduleRunTopicBuScheduleRun.


        :param message_count: The message_count of this WfmBuScheduleRunTopicBuScheduleRun.
        :type: int
        """
        
        self._message_count = message_count

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

