# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re
import json

from ..utils import sanitize_for_serialization

class WfmBuScheduleRunTopicBuSchedulingRunProgressNotification(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        WfmBuScheduleRunTopicBuSchedulingRunProgressNotification - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'operation_id': 'str',
            'state': 'str',
            'percent_complete': 'float',
            'intraday_rescheduling': 'bool',
            'run': 'WfmBuScheduleRunTopicBuScheduleRun'
        }

        self.attribute_map = {
            'operation_id': 'operationId',
            'state': 'state',
            'percent_complete': 'percentComplete',
            'intraday_rescheduling': 'intradayRescheduling',
            'run': 'run'
        }

        self._operation_id = None
        self._state = None
        self._percent_complete = None
        self._intraday_rescheduling = None
        self._run = None

    @property
    def operation_id(self):
        """
        Gets the operation_id of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.


        :return: The operation_id of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.
        :rtype: str
        """
        return self._operation_id

    @operation_id.setter
    def operation_id(self, operation_id):
        """
        Sets the operation_id of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.


        :param operation_id: The operation_id of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.
        :type: str
        """
        
        self._operation_id = operation_id

    @property
    def state(self):
        """
        Gets the state of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.


        :return: The state of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.
        :rtype: str
        """
        return self._state

    @state.setter
    def state(self, state):
        """
        Sets the state of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.


        :param state: The state of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.
        :type: str
        """
        allowed_values = ["None", "Queued", "Scheduling", "Canceled", "Failed", "Complete"]
        if state.lower() not in map(str.lower, allowed_values):
            # print "Invalid value for state -> " + state
            self._state = "outdated_sdk_version"
        else:
            self._state = state

    @property
    def percent_complete(self):
        """
        Gets the percent_complete of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.


        :return: The percent_complete of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.
        :rtype: float
        """
        return self._percent_complete

    @percent_complete.setter
    def percent_complete(self, percent_complete):
        """
        Sets the percent_complete of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.


        :param percent_complete: The percent_complete of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.
        :type: float
        """
        
        self._percent_complete = percent_complete

    @property
    def intraday_rescheduling(self):
        """
        Gets the intraday_rescheduling of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.


        :return: The intraday_rescheduling of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.
        :rtype: bool
        """
        return self._intraday_rescheduling

    @intraday_rescheduling.setter
    def intraday_rescheduling(self, intraday_rescheduling):
        """
        Sets the intraday_rescheduling of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.


        :param intraday_rescheduling: The intraday_rescheduling of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.
        :type: bool
        """
        
        self._intraday_rescheduling = intraday_rescheduling

    @property
    def run(self):
        """
        Gets the run of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.


        :return: The run of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.
        :rtype: WfmBuScheduleRunTopicBuScheduleRun
        """
        return self._run

    @run.setter
    def run(self, run):
        """
        Sets the run of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.


        :param run: The run of this WfmBuScheduleRunTopicBuSchedulingRunProgressNotification.
        :type: WfmBuScheduleRunTopicBuScheduleRun
        """
        
        self._run = run

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

